
/*
 *   Copyright (C) International Business Machines  Corp., 2005
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2 only.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 * tpm_keyring's common header file
 *
 * Kent Yoder <kyoder@users.sf.net>
 *
 */

#ifndef _WRAPKEY_H_
#define _WRAPKEY_H_

#define NULL_HOBJECT	0
#define NULL_HPCRS	NULL_HOBJECT
#define NULL_HKEY	NULL_HOBJECT
#define NULL_HCONTEXT	NULL_HOBJECT
#define NULL_HTPM	NULL_HOBJECT

#define SHA1_HASH_SIZE		20

/* XXX This is a crude way of returning a meaningful error string to the app */
#define ReturnError(x, ...)					\
	do {							\
		char t3mpbuf[4096];				\
		snprintf(t3mpbuf, 4096, x, ##__VA_ARGS__);	\
		return strdup(t3mpbuf);				\
	} while (0)

#ifdef DEBUG
#define PRINT_ERR(x, ...)	fprintf(stderr, "%s:%d " x "\n", __FILE__,__LINE__,##__VA_ARGS__)
#define	LogDebug(x, ...)	fprintf(stderr, "%s:%d " x "\n", __FILE__,__LINE__,##__VA_ARGS__)

#define DEBUG_openssl_print_errors()	openssl_print_errors()
#else
#define LogDebug(x, ...)
#define DEBUG_openssl_print_errors()
#endif

typedef struct
{
	char *name;
	char *pass;
	char *path;
	char *host;
	RSA *sw_key;
	int bits;
	TSS_HKEY hSRK, hKey;
	TSS_HCONTEXT hContext;
} tpm_keyring_util_ctx;

#endif
