
%module tpm_keyring_util

%{
#include <openssl/rsa.h>

typedef struct
{
	char *srk_pass, *name, *sw_pass, *path;
	char *host;
	unsigned int hSRK, hKey, hContext;
	int bits;
	RSA *sw_key;
} tpm_keyring_util_ctx;

%}

tpm_keyring_util_ctx *
tpm_keyring_util_create_ctx(int bits, char *name, char *pass, char *host, char *path);
char *tpm_keyring_util_create_group(tpm_keyring_util_ctx *ctx);
char *tpm_keyring_util_create_group_retry(tpm_keyring_util_ctx *ctx, char *pass);
char *tpm_keyring_util_import(char *name);
char *tpm_keyring_util_unregister_local(char *name);
char *tpm_keyring_util_send_key(tpm_keyring_util_ctx *ctx);
char *tpm_keyring_util_send_key_retry(tpm_keyring_util_ctx *ctx, char *pass);
char *tpm_keyring_util_remove_swkey(char *name, char *path);
void  tpm_keyring_util_ctx_close(tpm_keyring_util_ctx *ctx);
char *tpm_keyring_util_get_uuid(char *name);
int   tpm_keyring_util_get_keysize(char *name);


